#!/bin/sh

# get_tape_serial_from_drive.sh

function usage()
{
	echo "Usage: get_tape_serial_from_drive.sh -s <drive-serial-number>"
	echo "       get_tape_serial_from_drive.sh -d <drive-id>"
	echo ""
}

if [ $# -ne 2 ]; then
	usage
	exit 1
fi

action=""
if [[ $1 == "-d" ]] ;then
	action="drive"
elif [[ $1 == "-s" ]]; then
	action="serial"
else
	usage
	exit 1
fi

drive_info="$2"

result=`system_profiler SPSASDataType | grep "SAS Address\|Model" | awk ' BEGIN { last=""; } { if (index($0, "Ultrium") > 0 || index($0, "ULTRIUM") > 0) { print last; last=""; } else { last=$0; } }' | sed 's/\://g' | awk ' { print tolower($NF)",ntape"FNR-1; } ' | sort | awk ' { print FNR-1 "," $0"#"; }' | awk ' { print $0; }'`

if [ $? -ne 0 ]; then
	echo $drive_serial
	exit 1
fi

array=($(echo "$result" | tr '#' ' '))

for element in "${array[@]}"
do
    match=0
    elementarray=($(echo "$element" | tr ',' ' '))
    device_serial=`ioreg -l -w0 -c IOSCSITargetDevice | grep -A1 -B1 ${elementarray[1]} | grep "Unit Serial Number" | awk ' { print $NF; }' | sed 's/\"//g'`  
    if [ -f "/Library/Preferences/com.storagedna.sdna_tape_tracker_${elementarray[0]}.plist" ]; then

    	if [[ "${action}" == "serial" ]]; then
		if [[ "${device_serial}" == "${drive_info}" ]]; then
			match=1
		fi
	elif [[ "${action}" == "drive" ]]; then
		if [[ ${elementarray[0]} == "${drive_info}" ]]; then
			match=1
		fi
	fi

	if [ $match -eq 1 ]; then
    		result=`defaults read /Library/Preferences/com.storagedna.sdna_tape_tracker_${elementarray[0]}.plist serial`
		if [ $? -eq 0 ]; then
			echo $result | awk ' { print substr($1,0,6); } '
			exit 0
		fi
	fi
    fi
done

exit 1
